
;+ ***********************************************************************
; NAME:
;	LOADINTENS
;
; PURPOSE:
;	Cette procedure extrait une image STOKES I d'un tableau d'images.
;
; CATEGORY:
;	NRH1 fichier
;
; CALLING SEQUENCE:
;	LOADINTENS , Tabl, Image, Num, Finfo, Lun
;
; INPUTS:
;	TABL	Tableau contenant les images (voir LEC1D pour le format)
;
;	NUM	Indice de l'image a extraire dans le tableau
;  Parametres conserves pour la compatibilite des programmes
;	FINFO	Structure d'indormation de fichier (NRH1_FILEINFO)
;	LUN	Unite logique de lecture
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	IMAGE	Tableau 1 dim contenant l'image
;
; COMMON BLOCKS:
;	Non
;
; RESTRICTIONS:
;
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	16/11/98 Adapte du logiciel XHELIO
;-*******************************************************************

PRO LoadIntens, Tabl_x,imageX1,num,FichInfo,lun
  s = SIZE(tabl_X)

  IF s(0) EQ 3 THEN IMAGEX1=REFORM(Tabl_x(*,num,0)) $   ; prend tabl. intensite

  ELSE IMAGEX1 = Tabl_x(*,num)

END

