

;+ ***********************************************************************
; NAME:
;	LOADPOLAR
;
; PURPOSE:
;	Cette procedure extrait une image STOKES V d'un tableau d'images.
;	Si STOKES V est abscent, IMAGE = STOKES I
;
; CATEGORY:
;	NRH1 fichier
;
; CALLING SEQUENCE:
;	LOADPOLAR , Tabl, Image, Num, Finfo, Lun, Ok
;
; INPUTS:
;	TABL	Tableau contenant les images (voir LEC1D pour le format)
;
;	NUM	Indice de l'image a extraire dans le tableau
;  Parametres conserves pour la compatibilite des programmes
;	FINFO	Structure d'indormation de fichier (NRH1_FILEINFO)
;	LUN	Unite logique de lecture
;	OK	=1 si STOKES V est abscent
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	IMAGE	Tableau 1 dim contenant l'image
;
; COMMON BLOCKS:
;	Non
;
; RESTRICTIONS:
;	Si STOKES V est abscent STOKES I est retourne ainsi que OK=1 et
;	envoi d'un message
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	16/11/98 Adapte du logiciel XHELIO
;-*******************************************************************


PRO LoadPolar , Tabl_x,imageX2,num,FichInfo,lun,ok
  s=SIZE(tabl_X)
  IF s(0) EQ 3 THEN BEGIN
    IMAGEX2=REFORM(Tabl_x(*,Num,1)) 
    ok=1
  ENDIF ELSE BEGIN
    IMAGEX2 = Tabl_x(*,num)
    ok=0
 	Ret=WIDGET_MESSAGE('No STOKES V on this file')
  ENDELSE

END
