
;+ ***********************************************************************
; NAME:
;	NRH1_XTEXT
;
; PURPOSE:
;	Cette procedure affiche un texte dans une fenetre X
;
; CATEGORY:
;	NRH1 general
;
; CALLING SEQUENCE:
;	NRH1_XTEXT,Texte,GROUP=group
;
; INPUTS:
;	TEXTE	tableau de chaines de caracteres a afficher	
;
; KEYWORD PARAMETERS:
;	GROUP	identifieur du widget appelant. Si non present
;			GROUP = mainstruc.root	
;
; OUTPUTS:
;	Listing de l'entete.
;
; COMMON BLOCKS:
;	 NRH1_HELIO,mainstruct
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	13/11/98 Adapte du logiciel XHELIO (JB)
;-*******************************************************************

PRO NRH1_xtext_event,ev

stash = WIDGET_INFO ( ev.top , /CHILD )
WIDGET_CONTROL, stash , GET_UVALUE = state

IF (ev.id EQ state.button) THEN BEGIN
    WIDGET_CONTROL, stash, SET_UVALUE = state 
    WIDGET_CONTROL, ev.top, /DESTROY
    RETURN
ENDIF

END


PRO NRH1_xtext,texte,Group=group

Common NRH1_HELIO,mainstruct


base = WIDGET_BASE(TITLE = ' ',/COLUMN, XOFFSET = 400, YOFFSET = 300 )
base_display = WIDGET_BASE(base,/FRAME,/ROW) 
base_message = WIDGET_BASE(base_display,/COLUMN)

s = N_ELEMENTS(texte)

IF (s EQ 0) THEN RETURN

message = WIDGET_TEXT(base_message,VALUE = string(texte),SCROLL=5,$
                      XSIZE=80,YSIZE=25)

button = WIDGET_BUTTON(base,VALUE = 'OK',/FRAME)

state = { button:button }

WIDGET_CONTROL, WIDGET_INFO ( base,/CHILD ) , $
                SET_UVALUE = state , /REALIZE
IF not keyword_set(group) THEN group=mainstruct.root
XMANAGER,'nrh1_xtext',base,GROUP_leader=GROUP, /NO_BLOCK
END
