
;+ ***********************************************************************
; NAME:
;	NEWLECP1D
;
; PURPOSE:
;	Cette fonction lit un fichier NRH de positions de centroid
;
; CATEGORY:
;	NRH1 Position
;
; CALLING SEQUENCE:
;	NEWLECP1D,Unit, Tabl, Str
;
; INPUTS:
;	UNIT	Unite de lecture associee au fichier
;	
; KEYWORD PARAMETERS:
;	FICHIER	Nom du fichier, sinon nom contenu dans NRH1_GLOBAL
;
;	OLDMODE	A voir
;
; OUTPUTS:
;	TABL	Tableau contenant le resultat (voir LECP1D pour le format)
;
;	STR	Structure d'information (voir LECP1D pour le format)
;
; COMMON BLOCKS:
;	NRH1_GLOBAL
;	NRH1_HELIO
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	20/11/98	Adapte du logiciel XHELIO (JB)
;-*******************************************************************

FUNCTION newlecp1d,lun,x,stx,FICHIER=fichier,OLDMODE=oldmode

Common NRH1_GLOBAL,nomfich,fichinfo
Common NRH1_HELIO,mainstruct

chemin=!chemin
pos=STRPOS(fichier,']')

IF ( pos NE -1) THEN BEGIN
  !chemin = STRMID(fichier,0,pos+1)
  fichier = STRMID(fichier,pos+1,100)
ENDIF

	SZ = SIZE(FINDFILE(!chemin+fichier))
IF SZ(0) EQ 0 THEN BEGIN
   !chemin=chemin
   $pwd
   RET = WIDGET_MESSAGE('File '+!chemin+fichier+' not found')
   RETURN,1
ENDIF

WIDGET_CONTROL,/HOURGLASS
if not keyword_set(fichier) THEN $
fichier = nomfich(lun)
;IF keyword_set(oldmode) THEN BEGIN
   lecp1d,lun,x,stx,FICHIER=fichier
;ENDIF ELSE BEGIN
;   x = FILELOAD(fichier)
;   IF N_elements(x) EQ 1 THEN BEGIN
;       lecp1d,lun,x,stx,FICHIER=fichier
;       ret=FILESTORE(x,fichier)
;   ENDIF ELSE BEGIN
;   err = newlitentete(lun,fichier,file)
;   IF err EQ 1 THEN RETURN,err
;   fichinfo(lun)=file
;   nomfich(lun)=fichier
;   ENDELSE
;ENDELSE

; regarde si c'est bien un fichier de positions 1D
; attention a l'espace devant POSITION
IF (MOTCLE(lun,'ENTETDESC1') NE ' POSITION') THEN BEGIN
    RET= WIDGET_MESSAGE('Not a centroid position file')
    RETURN,1
ENDIF


IF (MOTCLE(lun,'LABEL') eq 'EST-OUEST') THEN $
   mainstruct.pewfile=fichier $
ELSE $
   mainstruct.pnsfile=fichier
     

IF (pos NE -1) THEN $
!chemin=chemin
   

RETURN,0
END







