
;+ ***********************************************************************
; NAME:
;	CREATE_NRH_CFILE
;
; PURPOSE:
;	Cette procedure cree un fichier de type CFILE de NRH
;
; CATEGORY:
;	NRH flux
;
; CALLING SEQUENCE:
;	CREATE_NRH_FILE, FILE, HEADER, TYPE
;
; INPUTS:
;	FILE	nom du fichier a ouvrir
;
;	HEADER	Headre primaire du fichier ayant servi a calcukler le flux
;
;	TYPE	Type des donnees contenues dans le fichier, Chaine de 
;		caracteres mis dans le KEYWORD NRH_DATA
;
; PROCEDURE:
;	Cete procedure cree un fichier de resultats de calculs du NRH
;  s'il n'existe pas et ecrit le header primaire correspondant a partir du
;  header du fichier ayant servi au calcul
;	Si le fichier existe, elle est inoperante. Les donnees sont ecrites
;  dans les extensions suivantes
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin (obspm.fr) le 15/09/98
;-*******************************************************************

PRO CREATE_NRH_CFILE, File, Header, Type

HPRIM = Header

	r= FINDFILE(File)
	If R(0) EQ '' THEN BEGIN
		ERRMSg=''
		SXADDPAR, Hprim, 'DATE', FORM_DATE()
		SXADDPAR, Hprim, 'N_EXTEND', 0
		SXADDPAR, Hprim, 'NRH_DATA', Type,' '
		SXADDPAR, HPRIM, 'ORIGIN', 'write_fluxnrh.pro'
                    NOM = STR_SEP(File,'/')
                    Sz= Size(Nom)
		SXADDPAR, Hprim, 'FILENAME', Nom(sz(1)-1),' '
		WRITEFITS, File, 0, Hprim
	End
END
