
;+ ***********************************************************************
; NAME:
;	RD_NRH2I
;
; PURPOSE:
;	Lecture d'une image dans un fichier NRH2, l'image est selectionnee
;	par l'heure
;
; CATEGORY:
;	Fichiers
;
; CALLING SEQUENCE:
;	RD_NRH2I, FILE, HEURE, STRINF, DATA, STR	
;
; INPUTS:
;	FILE	nom du fichier
;	HEURE	Chaine ASCII: hh:mn:ss:xxx, l'heure est prise en compte si
;		le keyword INDIC n'est pas present
;	STRINF	Structure resultant de NRH_FOPEN
;
; KEYWORD PARAMETERS:
;	STOKES	Image STOKESV si = 1, STOKESI si = 0 ou abscent
;
;	INDIC	Indice de l'image dans le fichier
;
; OUTPUTS:
;	DATA	Tableau d'image
;	STR	Structure decrivant l'image (NRH_STR_IMAGE)
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr) le 29/05/98
;-*******************************************************************

PRO RD_NRH2I, FILE, HEURE, Str_inf2d, DATA, STR, STOKES=Stokes, INDIC =indic

STR = {nrh_str_image}

IF NOT KEYWORD_SET(STOKES) THEN Stokes=0

IF Stokes EQ 2 AND Str_inf2d.Physpar NE 2 THEN BEGIN
	 r= WIDGET_MESSAGE('StokesV no exist for this file')
		Return & END

IF NOT KEYWORD_SET(INDIC) THEN INDIC = TIME_IND_NRH(File, Heure)

IF Str_Inf2d.Instrume EQ 'HSSI' THEN BEGIN 
	COL = fxbcolnum(Str_Inf2d.Unit,'DATA') 

ENDIF ELSE BEGIN	
	IF Stokes EQ 0 THEN BEGIN
		COL = fxbcolnum(Str_Inf2d.Unit,'STOKESI')
		Str.Physpar = 'STOKESI'
	END
	IF Stokes EQ 1 THEN BEGIN
		COL = fxbcolnum(Str_Inf2d.Unit,'STOKESV')
		Str.Physpar = 'STOKESV'
	END
ENDELSE

	FXBREAD, Str_inf2d.unit, TEMPS, Str_Inf2d.Ctime, Indic+1
	FXBREAD, Str_inf2d.Unit, DATA, Col, Indic+1

	Str.date = Str_inf2d.date
	Str.time = msh(Temps)
	Str.Freq = STRCOMPRESS(Str_inf2d.Freq,$
				/REMOVE_ALL)+'MHz'
	Str.Instrume = Str_inf2d.instrume
	Str.Crpixx =  Str_inf2d.Xcen
	Str.Crpixy =  Str_inf2d.Ycen
	Str.ray = Str_inf2d.Ray

END
	