
;+ ***********************************************************************
; NAME:
;	RD_NRHGIF
;
; PURPOSE:
;	Lecture des donnees SOHO EIT au format FITS
;
; CATEGORY:
;	Input, Output
;
; CALLING SEQUENCE:
;	 RD_NRHGIF, File, Str_fic, Image, Str_im

;
; INPUTS:
;	File	chemin et nom du fichier a lire
;	Str_fic	Structure d'information de fichiers (NRH_STR_INFIC)
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;	Image	tableau d'image
;	Str_im	Structure d'image (NRH_STR_IMAGE)
;
; PROCEDURE:
;	Cette procedure lit l'image contenue dans un fichier GIF,
;	cree et remplit la structure STR_IM
;	La structure STR_FIC doit avoit ete correctement remplie par un appel
;	a FOPEN_GIF
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr)le 09/09/98
;		Chargement des tables de couleurs GIF (JB Le 15/05/00)
;-*******************************************************************

PRO RD_NRHGIF, File, Str_inf2d, Image, Str

STR = {nrh_str_image}

        READ_GIF, File, Image, R, G, B

	TVLCT,R,G,B
 
	Str.date = Str_inf2d.date
	Str.time = Str_inf2d.hd
	Str.Freq = ''
	Str.Instrume = Str_inf2d.instrume
	Str.Crpixx =  Str_inf2d.Xcen
	Str.Crpixy =  Str_inf2d.Ycen
	Str.Ray = Str_inf2d.Ray
	
end