FUNCTION RS_IND, RS, Pcentre, Rayon

;+ ***********************************************************************
; NAME:
;	RS_IND
;
; PURPOSE:
;	Cette fonction donne  l'indice d'un pixel dans untableau
; a partir de la position en rayon solaire, l'indice du centre le l'image, 
; la dimension du rayon solaire en pixels
;
; CATEGORY:
;	RADIO
;
; CALLING SEQUENCE:
;	IND=IND_RS(RS, pcentre, rayon)
;
; INPUTS:
;	RS	Position du pixel en rayon solaire
;	Pcentre Indice du centre de l'image
;	Rayon	Nombre de pixels representant le rayon solaire
;
; OUTPUTS:
;	IND	Coordonnee en pixel
;
; EXAMPLE:
;	IND = RS_IND(-1, 32, 16)
;IND indice du pixel situe a -1 rayon solaire
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin le 21/10/97 (bonmartin@obspm.fr)
;		Le 29/03/99	FIX remplace par ROUND
;-*******************************************************************

	IND= ROUND(RS * Rayon) + Pcentre

return, ind

END