;+
; NAME:
;	CW_OPTPOS
;
; PURPOSE:
;	widget permettant de configurer les parametres du scan des images
;	et du tri des sources en position
;
; CATEGORY:
;	RH_2D, recherche de positions
;
; CALLING SEQUENCE:
;	CW_OPTPOS, GROUP=Group
;
; KEYWORD PARAMETERS:
;	GROUP:	Id de la widget appelante
;
; COMMON BLOCKS:
;	OPTPOSI, str_opt	
;
; MODIFICATION HISTORY:
; 	Written by:	C. Reni 10/03/1998
;-

PRO cw_optpos_Event, Event
COMMON OPTPOSI, str_opt
COMMON FIELDcw_optpos, FIELD3, FIELD4, FIELD10, FIELD13, FIELD14, FIELD39

  ;helpfile = '/disque1/user/dirhelio/nrhsw/nrhidl/sswnrh/radio/nrh/2dnrh/position/option_hlp.txt'

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 
  'BUTTON36': BEGIN				; Done
	WIDGET_CONTROL, FIELD3, GET_VALUE=temp & str_opt.Nbmax=temp
  	WIDGET_CONTROL, FIELD4, GET_VALUE=temp & str_opt.Facteur=temp
  	WIDGET_CONTROL, FIELD10, GET_VALUE=temp & str_opt.Seuil=temp
	WIDGET_CONTROL, FIELD39, GET_VALUE=temp & str_opt.Fmax=temp
  	WIDGET_CONTROL, FIELD13, GET_VALUE=temp & str_opt.ZoneX=temp
  	WIDGET_CONTROL, FIELD14, GET_VALUE=temp & str_opt.ZoneY=temp
	WIDGET_CONTROL, Event.Top, /DESTROY
      	END
  'BUTTON37': BEGIN				; Apply
	WIDGET_CONTROL, FIELD3, GET_VALUE=temp & str_opt.Nbmax=temp
  	WIDGET_CONTROL, FIELD4, GET_VALUE=temp & str_opt.Facteur=temp
  	WIDGET_CONTROL, FIELD10, GET_VALUE=temp & str_opt.Seuil=temp
	WIDGET_CONTROL, FIELD39, GET_VALUE=temp & str_opt.Fmax=temp
  	WIDGET_CONTROL, FIELD13, GET_VALUE=temp & str_opt.ZoneX=temp
  	WIDGET_CONTROL, FIELD14, GET_VALUE=temp & str_opt.ZoneY=temp
      	END
  'BUTTON38': BEGIN
	WIDGET_CONTROL, Event.Top, /DESTROY	; Cancel
      	END
  'BUTTON39': BEGIN				; Default
	WIDGET_CONTROL, FIELD3, SET_VALUE=5 & str_opt.Nbmax=5
  	WIDGET_CONTROL, FIELD4, SET_VALUE=1 & str_opt.Facteur=1
  	WIDGET_CONTROL, FIELD10, SET_VALUE=2.0 & str_opt.Seuil=2.0
	WIDGET_CONTROL, FIELD39, SET_VALUE=50 & str_opt.Fmax=50
  	WIDGET_CONTROL, FIELD13, SET_VALUE=2 & str_opt.ZoneX=2
  	WIDGET_CONTROL, FIELD14, SET_VALUE=2 & str_opt.ZoneY=2
      	END
  'BUTHELP': BEGIN
	CW_OPT_HLP
	;XDISPLAYFILE, helpfile, TITLE='Help', GROUP=Event.Top
	END

  ENDCASE

END

; DO NOT REMOVE THIS COMMENT: END MAIN13
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.

PRO cw_optpos, GROUP=Group
COMMON OPTPOSI, str_opt
COMMON FIELDcw_optpos, FIELD3, FIELD4, FIELD10, FIELD13, FIELD14, FIELD39

  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Options', $
      UVALUE='MAIN13')

  BASE2 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      TITLE='Scanning', $
      UVALUE='BASE2')

  LABEL9 = WIDGET_LABEL( BASE2, $
      FRAME=1, $
      UVALUE='LABEL9', $
      VALUE='Scanning')

  FieldVal167 = [ '1' ]
  FIELD3 = CW_FIELD( BASE2,VALUE=FieldVal167, $
      ROW=1, $
      INTEGER=1, $
      TITLE='Sources/image:', $
      UVALUE='FIELD3', $
      XSIZE=4)

  FieldVal232 = [ '2' ]
  FIELD4 = CW_FIELD( BASE2,VALUE=FieldVal232, $
      ROW=1, $
      INTEGER=1, $
      TITLE='Factor:', $
      UVALUE='FIELD4', $
      XSIZE=4)

  FieldVal815 = [ '2.0' ]
  FIELD10 = CW_FIELD( BASE2,VALUE=FieldVal815, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Elypse at Max/:', $
      UVALUE='FIELD10', $
      XSIZE=4)

  FieldVal214 = [ '50' ]
  FIELD39 = CW_FIELD( BASE2,VALUE=FieldVal214, $
      ROW=1, $
      INTEGER=1, $
      TITLE='Max flux (%):', $
      UVALUE='FIELD39', $
      XSIZE=3)

  BASE11 = WIDGET_BASE(MAIN13, $
      COLUMN=1, $
      FRAME=1, $
      MAP=1, $
      TITLE='Sorting', $
      UVALUE='BASE11')

  LABEL12 = WIDGET_LABEL( BASE11, $
      FRAME=1, $
      UVALUE='LABEL12', $
      VALUE='Sorting')

  FieldVal1004 = [ '2' ]
  FIELD13 = CW_FIELD( BASE11,VALUE=FieldVal1004, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Area EW(pixels):', $
      UVALUE='FIELD13', $
      XSIZE=4)

  FieldVal1069 = [ '2' ]
  FIELD14 = CW_FIELD( BASE11,VALUE=FieldVal1069, $
      ROW=1, $
      FLOAT=1, $
      TITLE='Area NS(pixels):', $
      UVALUE='FIELD14', $
      XSIZE=4)

  BUTTON36 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON36', $
      VALUE='Done')

  BUTTON37 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON37', $
      VALUE='Apply')

  BUTTON38 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON38', $
      VALUE='Cancel')

  BUTTON39 = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON39', $
      VALUE='Default')

  BUTHELP = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTHELP', $
      VALUE='Help')

  WIDGET_CONTROL, MAIN13, /REALIZE

  WIDGET_CONTROL, FIELD3, SET_VALUE=str_opt.Nbmax
  WIDGET_CONTROL, FIELD4, SET_VALUE=str_opt.Facteur
  WIDGET_CONTROL, FIELD10, SET_VALUE=str_opt.Seuil
  WIDGET_CONTROL, FIELD39, SET_VALUE=str_opt.Fmax
  WIDGET_CONTROL, FIELD13, SET_VALUE=str_opt.ZoneX
  WIDGET_CONTROL, FIELD14, SET_VALUE=str_opt.ZoneY

  XMANAGER, 'cw_optpos', MAIN13
END
