
;+ *************************************************************************************
; NAME:
;	READ_NRHPOS
;
; PURPOSE:
;	Cette procedure lit une position dans un fichier de positions NRH  
;
; CATEGORY:
;	RH_2D, recherche de positions
;
; CALLING SEQUENCE:
;	READ_NRHPOS, Fichpos, NumPos, Strpos, Hext
;
; INPUTS:
;	Fichpos:	Fichier fits contenant les positions
;	NumPos:		Numero de la position
;
; OUTPUTS:
;	Strpos:		structure de 8 tableaux
;	Hext:		header de l'extension
;
; MODIFICATION HISTORY:
;	Ecrit par: 	C Renie octobre 1998
;- *************************************************************************************


PRO read_nrhpos, fichposi, posi, str_pos, hext

	hext = HEADFITS(fichposi, EXTEN=posi)
	nbhits = FXPAR(hext, 'NAXIS1')/(FXPAR(hext, 'TFIELDS')*4)
	str_pos = {time:LONARR(nbhits), intensity: FLTARR(nbhits), $
		 ewpos: FLTARR(nbhits),  nspos: FLTARR(nbhits), $
		 majaxis: FLTARR(nbhits),  minaxis: FLTARR(nbhits), $
		 angle: FLTARR(nbhits), flux: FLTARR(nbhits)}	
	str_pos.time = rdfilepos(fichposi, 'TIME', posi)
	str_pos.intensity = rdfilepos(fichposi, 'INTENSITY', posi)
	str_pos.ewpos = rdfilepos(fichposi, 'EWPOS', posi)
	str_pos.nspos = rdfilepos(fichposi, 'NSPOS', posi)
	str_pos.majaxis = rdfilepos(fichposi, 'MAJAXIS', posi)
	str_pos.minaxis = rdfilepos(fichposi, 'MINAXIS', posi)
	str_pos.angle = rdfilepos(fichposi, 'ANGLE', posi)
	str_pos.flux = rdfilepos(fichposi, 'FLUX', posi)

END
