
;+ ***********************************************************************
; NAME:
;	NRH_BIASREG
;
; PURPOSE:
;	Cette procedure determine une region sur une image apres rotation
;
; CATEGORY:
;	NRH2 project
;
; CALLING SEQUENCE:
;	NRH_BIASREG, Data, Angle, X, Y, Nx, Ny
;
; INPUTS:
;	DATA	Tableau contenant une image
;	ANGLE	Angle de rotation en degres
;
; OPTIONAL INPUTS:
;	Parm2:	Describe optional inputs here. If you don't have any, just
;		delete this section.
;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	X, Y	Coordonnees de la region coin bas a gauche
;	NX, NY	Nombre de pixels en X et Y
;
; COMMON BLOCKS:
;	Non
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr) le 09/07/99
;-*******************************************************************

PRO NRH_BIASREG, Data, Angle, X, Y, Nx, Ny


	LIGNE = PROFIL(Data, Xdir, Ydir)

	DX= Xdir((SIZE(Xdir))(1)-1) - Xdir(0)
	DY= Ydir((SIZE(Ydir))(1)-1) - Ydir(0)

	ANGLE = ATAN( FLOAT(DY) / FLOAT(DX)) *180 / !PI

	SZ= SIZE(Data) & DIM = SQRT(SZ(1)^2 + SZ(2)^2)
		IMAGE= FLTARR (Dim, Dim)
	Xl = Dim/2 - Sz[1]/2
	Yl = Dim/2 - Sz[2]/2
	Image[Xl:Xl+Sz[1]-1,Yl:Yl+Sz[2]-1] = Data
	IMAGE = ROT(Image, Angle)

	WINDOW,/FREE, XSIZE=(SIZE(Image))(1), YSIZE=(SIZE(Image))(2)
	TVSCL, Image
	BOX_CURSOR2, X, Y, Nx, Ny
	WDELETE

END

