; ----------------------------------------------------
; RH.EW, RH.NS = Position EW, NS de chaque correlation
; ----------------------------------------------------

PRO RH_INIT_PHA, RH, DON, SOURCE, NS, NH, NBFREQ, LAMBDA

@rh_common.inc

  NH = ENTFI.NVAL/4
  RH = REPLICATE({EW:0.,NS:0.},NH)

  for i=0,NH-1 do begin
      RH(i).EW=(ENTFI.PXANT(ENTFI.COREL(1,i))$
		-ENTFI.PXANT(ENTFI.COREL(0,i)))/1.E3
      RH(i).NS=(ENTFI.PYANT(ENTFI.COREL(1,i))$
		-ENTFI.PYANT(ENTFI.COREL(0,i)))/1.E3
  endFOR

NS=2
SOURCE=REPLICATE({H:0.,D:0.,DIAM:0.,INTENS:0.},2,ENTFI.NF)
NBFREQ=ENTFI.NF

DON={U:-0.00380,HEW:34102.4,HNS:579600.,$
     A:0.8264204,HSO:ENTFI.MER(0)*3600000.+ENTFI.MER(1)*60000.+$
	ENTFI.MER(2)*1000.+ENTFI.MER(3)*10.,$
	DSO:(ENTFI.DEC(0)+ENTFI.DEC(1)/60.+$
	ENTFI.DEC(2)/3600.+ENTFI.DEC(3)/360000.)*0.01745329}
DELTA=(3.86E-4+ENTFI.FRQ(0:ENTFI.NF-1)*5.72E-9)/2.

IF nbfreq EQ 1 THEN begin

SOURCE(0,0).H=DELTA*COS(.353)/COS(DON.DSO)
SOURCE(0,0).D=DELTA*SIN(.353)
SOURCE(0,0).DIAM=4.126E-5
SOURCE(0,0).INTENS=1.*((entfi.frq(0)/1690.)^(-0.816))/1.812
SOURCE(1,0).H=-DELTA*COS(.353)/COS(DON.DSO)
SOURCE(1,0).D=-DELTA*SIN(.353)
SOURCE(1,0).DIAM=4.126E-5

ENDIF ELSE BEGIN

SOURCE(0,*).H=REFORM(DELTA(*)*COS(.353)/COS(DON.DSO),1,nbfreq)
SOURCE(0,*).D=REFORM(DELTA(*)*SIN(.353),1,nbfreq)
SOURCE(0,*).DIAM=4.126E-5
for i=0,nbfreq-1 do SOURCE(0,i).INTENS=1.*((entfi.frq(i)/1690.)^(-0.816))/1.812
SOURCE(1,*).H=REFORM(-DELTA(*)*COS(.353)/COS(DON.DSO),1,nbfreq)
SOURCE(1,*).D=REFORM(-DELTA(*)*SIN(.353),1,nbfreq)
SOURCE(1,*).DIAM=4.126E-5

ENDELSE

SOURCE(1,*).DIAM=4.126E-5
for i=0,nbfreq-1 do SOURCE(1,i).INTENS=.812*((entfi.frq(i)/1690.)^(-0.816))/1.812
; temp est la pour rappeler l'erreur faite et la correction a faire
temp=dblarr(entfi.nf)
TEMP(*)=0.35D
TAB=WHERE(entfi.frq(*) GT 3850.,C)
IF C GT 0 THEN TEMP(tab)=-0.75D
;LAMBDA=2997.925D/(ENTFI.FRQ(0:ENTFI.NF-1)*1D + temp)
LAMBDA=2997.925D/(ENTFI.FRQ(0:ENTFI.NF-1)*1D )
END

PRO RH_PHI_LOB,LAMB,H,D,PHA,U,V

TEMP1=(H-D.HEW-D.HSO)*7.27220522D-8
TEMP2=(H-D.HNS-D.HSO)*7.27220522D-8
U(0)=1./LAMB*(COS(D.DSO)*COS(TEMP1))
U(1)=1./LAMB*(COS(D.DSO)*SIN(D.A)*SIN(TEMP2))
V(0)=1./LAMB*(D.U*COS(D.DSO)-SIN(D.DSO)*SIN(TEMP1))
V(1)=1./LAMB*(COS(D.A)*COS(D.DSO)+SIN(D.DSO)*COS(TEMP2)*SIN(D.A))

PHA(0)=1./LAMB*(COS(D.DSO)*SIN(TEMP1)+D.U*SIN(D.DSO))*2.D*3.141592456D
PHA(1)=1./LAMB*(COS(D.DSO)*COS(TEMP2)*SIN(D.A)+$
		SIN(D.DSO)*COS(D.A))*2.D*3.141592456D
END
