PRO CORR_ANT,  $
	g_E2,      g_E1,    g_E0,    g_NS0_ew,  g_H15,    g_H16,   $ ; entree
	g_NS0_ns,  g_NS8,   g_NS21,  g_NS22,    g_NS23,   g_NS45,  $ ; entree
	correl,						           $ ; entree
	harm_N						; entree et sortie.

; Creation 20 mai 03

; But correction manuelle et pragmatique de certaines antennes dont le gain est
;  . soit mal determine dans la calibration,
;  . soit rapidement instable dans le temps,
;  tant que le reseau n'est pas fiabilis'e.

    i_c = complex(0, 1)

    i_E2 = nint(g_E2(0))
    a_E2 = g_E2(1)
    p_E2 = g_E2(2) * !pi/180		; en radians
    gc_E2 = a_E2 * exp(i_c * p_E2)	; gc_  comme gain complexe, pour ne pas
					;   ecraser l'entree.


    i_E1 = nint(g_E1(0))
    a_E1 = g_E1(1)
    p_E1 = g_E1(2) * !pi/180		; en radians
    gc_E1 = a_E1 * exp(i_c * p_E1)

    i_E0 = nint(g_E0(0))
    a_E0 = g_E0(1)
    p_E0 = g_E0(2) * !pi/180		; en radians
    gc_E0 = a_E0 * exp(i_c * p_E0)

    i_NS0_ew = nint(g_NS0_ew(0))
    a_NS0_ew = g_NS0_ew(1)
    p_NS0_ew = g_NS0_ew(2) * !pi/180		; en radians
    gc_NS0_ew = a_NS0_ew * exp(i_c * p_NS0_ew)

    i_H16 = nint(g_H16(0))
    a_H16 = g_H16(1)
    p_H16 = g_H16(2) * !pi/180		; en radians
    gc_H16 = a_H16 * exp(i_c * p_H16)

    i_H15 = nint(g_H15(0))
    a_H15 = g_H15(1)
    p_H15 = g_H15(2) * !pi/180		; en radians
    gc_H15 = a_H15 * exp(i_c * p_H15)

    i_NS0_ns = nint(g_NS0_ns(0))
    a_NS0_ns = g_NS0_ns(1)
    p_NS0_ns = g_NS0_ns(2) * !pi/180		; en radians
    gc_NS0_ns = a_NS0_ns * exp(i_c * p_NS0_ns)

    i_NS8 = nint(g_NS8(0))
    a_NS8 = g_NS8(1)
    p_NS8 = g_NS8(2) * !pi/180		; en radians
    gc_NS8 = a_NS8 * exp(i_c * p_NS0_ns)

    i_NS21 = nint(g_NS21(0))
    a_NS21 = g_NS21(1)
    p_NS21 = g_NS21(2) * !pi/180		; en radians
    gc_NS21 = a_NS21 * exp(i_c * p_NS21)

    i_NS22 = nint(g_NS22(0))
    a_NS22 = g_NS22(1)
    p_NS22 = g_NS22(2) * !pi/180		; en radians
    gc_NS22 = a_NS22 * exp(i_c * p_NS22)

    i_NS23 = nint(g_NS23(0))
    a_NS23 = g_NS23(1)
    p_NS23 = g_NS23(2) * !pi/180		; en radians
    gc_NS23 = a_NS23 * exp(i_c * p_NS23)

    i_NS45 = nint(g_NS45(0))
    a_NS45 = g_NS45(1)
    p_NS45 = g_NS45(2) * !pi/180		; en radians
    gc_NS45 = a_NS45 * exp(i_c * p_NS45)

; Rangement des harmoniques dans harm_N
 	;  NS0  avec E2, E1, H1 a H16		  	  0 a  17
	;  NS1  ---- ------------------------------      18 a  35
	;  NS8  ---- ------------------------------	144 a 161
	;  NS23 ---- ------------------------------     414 a 431
	;  NS45	---- ------------------------------     432 a 449

	; jusqu'au 7 oct 98 inclus:
	;  E0	---- NS0  a NS17			450 a 467
	;  --   ---- NS10 a NS23                        468 a 481
	;  --	---- NS45                               482
	;  --	---- NS7  a NS9                         483 a 485
	; a partir du 8 oct 98 inclus:
	;  NS45	---- NS0  a NS17			450 a 467
	;  --   ---- NS10 a NS23                        468 a 481
	;  --	---- NS45                               482
	;  --	---- NS7  a NS9                         483 a 485

	;  E2	---- E2, E1, H1 a H16			486 a 503
	;  E1	---- E2, E1, H1 a H16			504 a 521
	;  E0	---- E2, E1, H1 a H16			522 a 539
	;  NS8	---- NS0  a NS17			540 a 557
	;  NS0	---- NS10 a NS23 et NS45		558 a 572
	;  ---	---- NS7 a NS9				573 a 575

    if (i_NS0_ew eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(9 + 18*i) = harm_N(9 + 18*i) / gc_NS0_ew
	harm_N(503 - 8) = harm_N(503 - 8) / gc_NS0_ew			; E2
	harm_N(521 - 8) = harm_N(521 - 8) / gc_NS0_ew			; E1
	harm_N(539 - 8) = harm_N(539 - 8) / gc_NS0_ew			; E0
    endif

    if (i_E2 eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(0 + 18*i) = harm_N(0 + 18*i) / gc_E2
	harm_N(486) = harm_N(486 : 503) / conj(gc_E2)		; E2 a H16
	harm_N(504) = harm_N(504) / gc_E2			; E1
	harm_N(522) = harm_N(522) / gc_E2			; E0
    endif

    if (i_E1 eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(1 + 18*i) = harm_N(1 + 18*i) / gc_E1
	harm_N(487) = harm_N(487) / gc_E1			; E2 
	harm_N(504) = harm_N(504 : 521) / conj(gc_E1)		; E2 a H16
	harm_N(523) = harm_N(523) / gc_E1			; E0
    endif

    if (i_E0 eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(2 + 18*i) = harm_N(2 + 18*i) / gc_E0
	harm_N(522) = harm_N(522 : 539) / conj(gc_E0)		; E2 a H16
    endif

    if (i_H15 eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(16 + 18*i) = harm_N(0 + 18*i) / gc_H15
	harm_N(502) = harm_N(502) / gc_H15			; E2
	harm_N(520) = harm_N(520) / gc_H15			; E1
 	harm_N(538) = harm_N(538) / gc_H15			; E0
   endif

    if (i_H16 eq 1) then begin
	for i=0, 24 do $					; NS0 a NS45
	    harm_N(17 + 18*i) = harm_N(0 + 18*i) / gc_H16
	harm_N(503) = harm_N(503) / gc_H16			; E2
	harm_N(521) = harm_N(521) / gc_H16			; E1
 	harm_N(539) = harm_N(539) / gc_H16			; E0
   endif

    if (i_NS0_ns eq 1) then begin
	harm_N(0) = harm_N(0 : 17     ) / conj(gc_NS0_ns)	; E2 a H16
	harm_N(450) = harm_N(450      ) /      gc_NS0_ns		; NS45
	harm_N(558) = harm_N(558 : 575) / conj(gc_NS0_ns)	; NS7 a NS23
    endif

    if (i_NS8 eq 1) then begin
	harm_N(144) = harm_N(144 : 161) / conj(gc_NS8)		; E2 a H16
	harm_N(458) = harm_N(458) / gc_NS8			; NS45
	harm_N(484) = harm_N(484) / gc_NS8			; NS45
	harm_N(540) = harm_N(540 : 557) / conj(gc_NS8)		; NS0 a NS17
	harm_N(574) = harm_N(574) / gc_NS8			; NS0
    endif

    if (i_NS21 eq 1) then begin
	harm_N(378) = harm_N(378 : 395) / conj(gc_NS21)		; E2 a H18
	harm_N(479) = harm_N(479) / gc_NS21			; NS45
	harm_N(569) = harm_N(569) / gc_NS21			; NS0_ns
    endif

    if (i_NS22 eq 1) then begin
	harm_N(396) = harm_N(396 : 413) / conj(gc_NS22)		; E2 a H18
	harm_N(480) = harm_N(480) / gc_NS22			; NS45
	harm_N(570) = harm_N(570) / gc_NS22			; NS0_ns
    endif

    if (i_NS23 eq 1) then begin
	harm_N(414) = harm_N(414 : 431) / conj(gc_NS23)		; E2 a H18
	harm_N(481) = harm_N(481) / gc_NS23			; NS45
	harm_N(571) = harm_N(571) / gc_NS23			; NS0_ns
    endif

    if (i_NS45 eq 1) then begin
	harm_N(432) = harm_N(432 : 449) / conj(gc_NS45)		; E2 a H16
	harm_N(450) = harm_N(450 : 485) / conj(gc_NS45)		; ns0 a NS23
	harm_N(572) = harm_N(572      ) /      gc_NS45		; NS7 a NS23
    endif

    end			; fin de  CORR_ANT.


;______________________________________________________________________________

PRO RECALIBRATION,  i_np_p,  freq,  dir_cor,  ch_cor, $	; entree.
		    correl,  			      $	; entree
		    harm_N				; entree et sortie.

; Creation 21 mai 03
; But : faire une recalibration de  harm_N_np  ou de  harm_N_p  a partir de 
;	fichiers de coefficients multiplicatifs de correction existants.


    ch_freq = string(nint(freq))
    ch_freq = strcompress(ch_freq, /remove_all)

; Declarations
    ch_1 = ' '   & ch_2 = ' '   & ch_3 = ' '   & ch_4 = ' '
    ch_a = ' '   & j = 1 

; Lecture du fichier de correction non polar ou polar
    if (i_np_p eq 0) then ch_np_p = '_np'
    if (i_np_p eq 1) then ch_np_p = '_p'
;  Lecture de l'entete (avec date et frequence)
    nom_fich_cor = dir_cor + 'coeff_corr_' + ch_cor + '_' + ch_freq + $
								ch_np_p
    openr, unit, nom_fich_cor, /get_lun
    readf, unit, ch_1	; 1ere ligne.
    readf, unit, ch_2	; 2eme ligne : date et frequence
    readf, unit, ch_3  & readf, unit, ch_4	; fin en-tete.
    if (i_np_p eq 0) then  print,  $
	'Fichier des coefficients multiplicatifs de correction non polar :'
    if (i_np_p eq 1) then  print,  $
	'Fichier des coefficients multiplicatifs de correction polar :'
    print, '    ' + ch_2
;  Lecture des gains et phases
    ch_format = "(i4, 2x, f6.2, 5x, i4, a)"    ; repris de CALIBRATION.
    amp = fltarr(44)		& phas = intarr(44)
    for i = 0, 43 do begin
	readf, unit, format=ch_format,  j, amp_i, phas_i, ch_a
		; refuse de remplir directement amp(i) et phas(i).
	if (i ne j) then begin
	    if (i_np_p eq 0) then print, $
		'pb lecture fichier de correction non polar', freq, ' MHz'
	    if (i_np_p eq 1) then print, $
		'pb lecture fichier de correction polar', freq, ' MHz'
	    stop
	endif
	amp(i) = amp_i		& phas(i) = phas_i
    endfor
    close, unit
    free_lun, unit

    i_c = complex(0, 1)
    cmul = amp * exp(i_c * !pi/180 * phas)

; Correction de harm_N_np  (ou  harm_N_p)
    fac_corr  = conj(cmul(correl(0, *)) ) * cmul(correl(1, *))
    harm_N = harm_N * fac_corr

    end		; fin de RECALIBRATION.

;______________________________________________________________________________

PRO RECALIB_CORR_ANT

; Creation 21 mai 02

; But : compiler les procedures de recalibration et de correction pragmatique 
;	de gain des antennes ci-dessus

    J_M = 0	; seul certitude de la calibration
    end
