; ----------------------------------------------------------------------
;                           Definition du common RH_COMMON   
; ----------------------------------------------------------------------
;                     common RH_COMMON, sFI, entFI, aFI, bFI, luFI
; ----------------------------------------------------------------------
;
; STRUCTURE sFI (status)
; ====================== 
;
; numero logique du fichier			sFI.unit	Long
; nom du fichier				sFI.name	String
; mode de lecture 0-mono, 1-multi		sFI.mode	int
; table de correspondance correlation/type	sFI.tFI		Intarr(4,576) 
; sFI.tFI(*,k) = 0 si k = correlation EW
;                1 si k = correlation NS
;                2 si k = correlation 2D
;
; STRUCTURE entFI (entete)
; ========================
;
; Longueur tete du fichier			entFI.lgent	Long
; Longueur du fichier				entFI.filesize	Long
; Longueur d'une acquisition, en octets		entFI.lg	Int
; Type des acq du fichier, 1-1D, 2-2D		entFI.typ	Int
; Codage des acquisitions, 2-16 bits		entFI.cod	Int
; Representation des acq, 0-Harm		entFI.rep	Int
; Nombre de valeurs  tete acq			entFI.lgtet	Int
; Nombre de valeurs  corps acq 			entFI.nval	Int
; Nombre de valeurs 2D	 	                entFI.nval_2d   Int
; Nombre de valeurs EW 				entFI.nval_ew	Int
; Nombre de valeurs NS	 			entFI.nval_ns	Int
; Type de donnees,'1D    ','2D    '		entFI.d_typ     Bytarr(6)
; Temps d'integration en millisecondes		entFI.itg	Long
; Date (jour, mois, an)				entFI.dat	Intarr(3)
; Reference de la source, en caracteres		entFI.ref	Bytarr(6)
; Heure meridien (Heure, minute, sec, centieme)	entFI.mer	Intarr(3)
; Declinaison (degres,',',')			entFI.dec	Intarr(3)
; Horloge 0-TU ou 1-TS				entFI.hg	Int
; Heure de debut (heure, minute)		entFI.hdeb	Intarr(4)
; Heure de fin en heure, minute)		entFI.hfin	Intarr(4)
; Nombre de frequences, de 1 a 10		entFI.nf	Int
; Table des frequences en centaines de Khz	entFI.frq	Intarr(10)
; Correction de trajectoire 1-avec ou 0-sans	entFI.trj	Int
; Compression 1-avec ou 0-sans			entFI.comp	Int
; Cycle recepteur, en millisecondes 		entFI.cyclms	Int
; Description donnees				entFI.d_obs	bytarr(78) 
; Reseau EW depointage 0-Sans, 1-Est, 2-Ouest	entFI.depew	Int
; Reseau EW depointage en minutes		entFI.dephew	Int
; Rotation dipoles ant 2, 4 EW 1-avec ou 0-sans	entFI.rotew	Int
; Rotation antenne 0 NS 1-avec ou 0-sans	entFI.rotns	Int
; Position EW des antennes en mm		entFI.pxant	Lonarr(44)
; Position NS des antennes en mm		entFI.pyant	Lonarr(44)
; Table des correlations (no Ref, no ant)	entFI.corel	intarr(2,576)
; 1 Tables de correction			entCOR:entCOR
; Description de l'observation			descrip		bytarr(80,2)
; Description de l'activite			activ		bytarr(80)
; Description des pannes			pannes		bytarr(80,3)
; Evenements non comprimes			evenements	bytarr(80,15)
; swap_endian a faire si = 1			endian		0L
; numero du dernier enregistrement		klumax		0L
;						libre		lonarr(57)
; structure entCOR
;
; Frequence, en cent de khz		entFI.entCOR.frq	int
; Date de phasage Jour, mois, annee	entFI.entCOR.dat	intarr(3)
; Source utilisee en caracteres		entFI.entCOR.ref	bytarr(6)
; Coefficient gain			entFI.entCOR.coeff_gain	int
; Gain  non polar * coeff / antenne	entFI.entCOR.gain_np	intarr(44)
; Gain  polar     * coeff / antenne	entFI.entCOR.gain_p	intarr(44)
; Phase non polar / antenne en degres	entFI.entCOR.phase_np	intarr(44)
; Phase polar     / antenne en degres	entFI.entCOR.phase_p	intarr(44)
;
; VARIABLE ASSOCIEE aFI
; ===================== 
;
; aFI variable associee a l'unite logique sFI.unit
;
; STRUCTURE bFI (acquisition brute)
; =================================
;
; fichier 1D 
; ----------
; nombre d'acq comprimees		bFI.c		int
; numero de frequence			bFI.nof		int
; heure					bFI.h		intarr(4) 
; gain EW, NS				bFI.g		intarr(2)
; harmoniques				bFI.pt		intarr(4, entfi.nval/4)
;
; fichier 2D
; ----------
; nombre d'acq comprimees		bFI.c		int
; numero de frequence			bFI.nof		int
; heure					bFI.h		intarr(4) 
; gain 2D, EW, NS			bFI.g		intarr(3)
; /					bFI.nul0		int
; harmoniques				bFI.pt		intarr(4, entfi.nval/4)
; /					bFI.nul1	intarr(n)
; n = entFI.lg/2-entFI.nval-entfi.lgtet
;
; si open avec Keyword MONO, bFI = replicate(bFI, entFI.nf)
;
; STRUCTURE luFI (acquisition decodee)
; ====================================
;
; gain					luFI.g		intarr(entFI.typ+1)
; harmoniques				luFI.pt		fltarr(4, entfi.nval/4)
;
; si open avec Keyword MONO, luFI = replicate(luFI, entFI.nf)
;
; ----------------------------------------------------------------------------
common RH_COMMON, sFI, entFI, aFI, bFI, luFI
; ----------------------------------------------------------------------------
