; ---------------------------------------------------------------- 
;                  RH_READBCH, klu, ch
; ----------------------------------------------------------------
; necessite rh_open en /MONO 
; Lit dans bFI du common RH la 1ere acquisition a partir de klu dont 
;  la frequence est selectionnee dans ch. 
;  Ici du fait de la selection de frequences, KLU est incremente tant 
;  qu'aucune image de frequence choisie n'a ete lue.
;  klu n'est pas incremente pour l'image lue, l'incrementation doit
;  etre faite par le programme appelant.
; 
; INPUTS:
;	klu  : numero de l'acquisition a lire	LONG
;	       debut du fichier = 0L
;	ch   : 'Y' ou 'N' selection des frequences strarr(entfi.nf) 
; OUTPUTS:
;	klu  : numero de l'acq lue
;              = -999 si on a atteint la fin de fichier
;
; COMMON BLOCKS: 
;       RH
; -----------------------------------------------------------------  

PRO RH_READBCH, klu, ch

@rh_common.inc
  ks=0			; 
  WHILE (ks lt 1)do begin
	bFI = aFI(klu)
	IF (entFI.endian EQ 1) THEN bFI = swap_endian(bFI)
	if ch(bFI.nof) eq 'Y' THEN BEGIN             
  	      CASE entFI.typ OF
        	    '1' : luFI.g = bFI.g
      		    '2' : BEGIN
                          luFI.g(0:1) = bFI.g(1:2)
                          luFI.g(2)   = bFI.g(0)
                          END
	      ENDCASE
	      luFI.pt = float(bFI.pt(*,*))
	      ks=1
        endif else begin
              klu=klu+1L
              if klu gt entfi.klumax then begin
                  klu = -999L
                  return
              endif
	endelse
  ENDWHILE 	            
END
