; ---------------------------------------------------------------- 
;           Retourne l'heure h de l'acquisition klu	
; ---------------------------------------------------------------- 
; h = RH_READH(klu) 
; 	klu  : numero de l'acquisition a lire		LONG
;	       debut du fichier = 0L
; 	h    : heure (heure, min, sec, cent)		intarr(4)
; bug corrige : decembre 2006 
;              ind_h = 4L pour 1d 2d 4d, ind_h = 8L pour 3d
; ----------------------------------------------------------------  

FUNCTION RH_READH, klu 

@rh_common.inc

  k = klu
  IF sFI.mode EQ 1 THEN k = k*long(entFI.nf) ; =0 mono
  ind_h = 4L
  if (entFI.typ EQ 3 ) THEN ind_h = 8L ; tete acq differente pour le 3d
; Passage aux fichiers bruts 5Go : la position en octets doit etre un
; long64 et non long pour atteindre la fin de fichier.
  point_lun, sFI.unit, (entFI.lgent+k*long64(entFI.lg)+ind_h)
  h = intarr(4)
  readu, sFI.unit, h
  IF (entFI.endian EQ 1) THEN h = swap_endian(h)
  IF (entFI.typ EQ 3 OR entFI.typ EQ 4) THEN BEGIN
    h1=intarr(4)
    h1=rh_decodh(h)
    h = h1
  ENDIF  
  RETURN, h

END
