
;+ ***********************************************************************
; NAME:
;	C2IDATE
;
; PURPOSE:
;	Cette procedure convertit la date chaine de caracteres, en binaire
;
; CATEGORY:
;	NRH1 General
;
; CALLING SEQUENCE:
;	C2IDATE, Chdate, Idate	
;
; INPUTS:
;	CHDATE	Chaine de caracteres contenant DD-MMM-yyYY
;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	IDATE	Tableau de 3 valeurs	IDATE[0] = Jour
;					IDATE[1] = Mois
;					IDATE[2] = An
;
; COMMON BLOCKS:
;	Non
;
; SIDE EFFECTS:
;	La chaine de caracteres est decodee en fonction de la position des
;	caracteres dans la chaine, donc le separateur peut etre quelconque
;
; PROCEDURE:
;	La conversion inverse est faite par I2CDATE
;
; EXAMPLE:
;	C2IDATE, '20/APR/1998', IDATE
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
; 08-oct-1996
; Modif novembre 1997: Dates en anglais (KLK)
;
;-*******************************************************************

pro c2idate, chdate, idate


idate=lonarr(3)
mois =['JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC']
;mois =['JAN','FEV','MAR','AVR','MAI','JUN','JUI','AOU','SEP','OCT','NOV','DEC']
reads,chdate,ij,ia,format='(i2,7x,i2)'
chm=strupcase(strmid(chdate,3,3))
idate(0)=ij & idate(1)= where(mois eq chm)+1 & idate(2)=ia
return
end


