
;+ ***********************************************************************
; NAME:
;	NRH_ENVIRONNEMENT
;
; PURPOSE:
;	Cette procedure definit l'environnement permettant d'executer les procedures de
;	la branche NRH, 2DNRH
;	Elle est utilisee par HESSI_NRH
;
; CATEGORY:
;	HESSDI NRH
;
; CALLING SEQUENCE:
;	NRH_ENVIRONNEMENT
;

;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	Environnement NRH
;
;
; COMMON BLOCKS:
;	Creation des COMMON blocks
;		common visu_2d,str_visu
;		common FICRH,str_fic
;		common INFO2D, str_inf2d
;		common LIMIT,str_lim
;
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin (bonmartin@obspm.fr) le 12/03/01
;-*******************************************************************

PRO NRH_ENVIRONNEMENT

common visu_2d,str_visu
common FICRH,str_fic
common INFO2D, str_inf2d
common LIMIT,str_lim

IF !VERSION.OS_FAMILY EQ 'unix' THEN BEGIN
	SETENV,'NRH_DEV=X'
	DEVICE, DECOMPOSED=0, PSEUDO_COLOR=8
ENDIF
IF !VERSION.OS_FAMILY EQ 'Windows' THEN SETENV,'NRH_DEV=WIN'

IF N_ELEMENTS(Group) EQ 0 THEN Group = 0

	STR_VISU= {NRH_STR_VISU}
	STR_INF2D= {NRH_STR_INFIC}
	STR_lim = {NRH_STR_LIM}
	STR_FIC= {NRH_STR_FIC}

		Str_visu.Coord= 'I'	;Intensite
		Str_visu.dim = 256	;Dimension de l'image
		Str_visu.Inc = 1	;Incement
		Str_visu.Cont = 5	;Nombre de contours
		Str_visu.Pcent = 90	;Contour maximum
		Str_Visu.Mcent = 10	;Contour minimum

	CD, CURRENT= Rep
		Str_fic.REP= Rep

END
