
;+ ***********************************************************************
; NAME:
;	NRH_STR_INFIC__DEFINE	
;
; PURPOSE:
;	Definition de la structure NRH_STR_INFIC
;		Information de fichier
;
;NRH_STR_INFIC = {NRH_STR_INFIC
;		INSTRUME:'',	Instrument, utilise pour la lecture des 
;				donnees et pour les labels
;		CONTENT:'',	Contenu = definition de NRH_DATA
;		Unit:0,		Unite de lecture
;		Ctime:0,	Colonne TEMPS pour les tables binaires
;		Freq:0.0,		Frequence
;		Date:'',	Date ('JJ/Mois/AA')
;		Nim: 0,		Nombre de lignes dans le fichier
;		Npx: 0,		Nombre de pixels en X sur l'image
;		Npy: 0,		Nombre de points en Y sur l'image
;		Tscan: 0.0,	Duree d'integation
;		Xcen: 0.0,	Position X du centre de l'image
;		Ycen: 0.0,	Position Y du centre de l'image
;		Ray: 0.0,	Rayon en pixels
;		Hd: ' ',	Heure de debut(chaine ASCII)
;		Hf: ' ',	Heure de fin(chaine ASCII)
;		PHYSPAR:0,	Nombre de parametres physiques differents
;		MAX:0,		Valeur max contenue dans le fichier
;		MIN:0}		Valeur min contenue dans le fichier 
;
; CATEGORY:
;	Structure
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin le 04/06/98
;-*******************************************************************

PRO NRH_STR_INFIC__DEFINE


	NRH_STR_INFIC= {NRH_STR_INFIC,INSTRUME:'', $
			Content: '', $
			Unit: 0, Ctime:0, $
			Freq:0.0, Date:'', $
			NIM: 0L, NPX: 0, NPY: 0, $
			Xcen: 0.0, Ycen: 0.0, Ray: 0.0, $ 
			TSCAN: 0.0, HD: '', HF: '', PHYSPAR:0, $
			MAX: 0.0, MIN: 0.0} 

END